.LOROM

.SNESHEADER
 ID    "ABSN"
 NAME  "ANIKI BAKURESNSF"
 LOROM
 FASTROM
 CARTRIDGETYPE $00
 ROMSIZE $0B
 SRAMSIZE $00
 COUNTRY $00
 LICENSEECODE $33
 VERSION $00
.ENDSNES

.MEMORYMAP
 SLOTSIZE $8000
 DEFAULTSLOT 0
 SLOT 0 $8000
.ENDME

.ROMBANKSIZE $8000
.ROMBANKS 1

.SNESNATIVEVECTOR               ; Define Native Mode interrupt vector table
  COP EmptyHandler;$8491
  BRK EmptyHandler;$848B
  ABORT EmptyHandler
  NMI NmiEntry

  IRQ IrqEntry
.ENDNATIVEVECTOR

.SNESEMUVECTOR                  ; Define Emulation Mode interrupt vector table
  COP EmptyHandler

  ABORT EmptyHandler
  NMI EmptyHandler
  RESET ResetEntry
  IRQBRK EmptyHandler
.ENDEMUVECTOR


.BANK 0 SLOT 0

.ORG $7E00
.SECTION "SETUP" SEMIFREE

.DEFINE REQUESTCODE1 = $FE00
	.dw	$000B
.DEFINE REQUESTCODE2 = $FE02
	.dw	$0000

RESETGATE:
	SEI
	BRA	Start

EmptyHandler:
	RTI

NMIGATE2:
	JMP	VBlank2

ResetEntry:
	JMP	$80FE04

IrqEntry:
	JMP	$8084E5

NmiEntry:
	REP	#$30
	PHA
	LDA	REQUESTCODE1.L
	CMP	#$000B
	BNE	NmiCall2
	PLA
	JMP	$80849A

NmiCall2:
	PLA
	JMP	$80FE08

Start:

	SEP	#$30
	CLC
	XCE

;MEMORY CLEAR
	REP	#$20
	LDA	#$0000
	TCD
	SEP	#$20
	LDA	#$00
	PHA
	PLB
	STZ	$4200
	REP	#$10
	LDX	#$013F
	TXS
	STZ	$0400
	SEP	#$20
	LDA	#$01
	STA	$420D
	LDA	#$7E
	PHA
	PLB
	REP	#$30
	LDA	#$0000
	LDX	#$0000
_MCLP:
	STA	$0000,x
	DEX
	DEX
	BNE	_MCLP
	SEP	#$20
	LDA	#$00
	PHA
	PLB
	REP	#$30
	STZ	$01BD
	STZ	$01BF

	; SOUND RESET
	JSL	$80FC00

	REP	#$20
	LDA	REQUESTCODE1.L
	CMP	#$000B
	BNE	_BGMPLAY

	REP	#$30
	LDA	#$0000
	STA	$7E5942.L
	STA	$000066.L
	STA	$7E594E.L
	STA	$00032E.L

;NMI ENABLE
	SEP	#$20
	LDA	#$01
	STA	$420D

	LDA	$0001C3.L
	ORA	#$80
	STA	$002100.L

_OPENING:
	SEP	#$20
	LDA	#$80
	PHA
	PLB
	REP	#$20
	LDA	#$0008
	STA	$7E5920.L
	LDA	#$0003
	STA	$7E5922.L
	LDA	#$FFFF
	STA	$20
	LDA	#$81BD
	JMP	$936C

_BGMPLAY:
	REP	#$30		; A/Mem = 16 bit, X/Y = 16 bit

	STA 	$7E6365.L

	JSR	SetupVideo

	SEP	#$30		; A/Mem = 8 bit, X/Y = 8 bit

	LDA	#$80
	STA	$4200		; Enable NMI

	CLI

	LDA	#$7E
	PHA
	PLB

_LFC57:
	REP	#$30		; A/Mem = 16 bit, X/Y = 16 bit

	WAI;JSL	$809464
	
	LDA	$000330.L

	BEQ	_LFC65

	JSL	$80806D

	REP	#$30		; A/Mem = 16 bit, X/Y = 16 bit
	LDA	#$000A
	JSL	$80FDC0

_LFC65:

	LDA	$7E6365.L
	BPL	_LFC6D
	BRA	_LFC87

_LFC6D:
	SEP	#$30		; A/Mem = 8 bit, X/Y = 8 bit
	TAY
	LDA	#$02
	JSL	$848000

	SEP	#$30		; A/Mem = 8 bit, X/Y = 8 bit
	LDA	#$05
	JSL	$848000

	REP	#$30		; A/Mem = 16 bit, X/Y = 16 bit
	LDA	#$FFFF
	STA	$7E6365.L

_LFC87:
	LDA	$7E6361.L
	CMP	#$FFFF
	BEQ	_LFCAE
	BPL	_LFC9C
	AND	#$00FF
	ASL	A
	TAX
	LDA	$636D,X
	BMI	_LFCA7
_LFC9C:
	SEP	#$30		; A/Mem = 8 bit, X/Y = 8 bit
	TAY
	LDA	#$03
	JSL	$848000
	REP	#$30		; A/Mem = 16 bit, X/Y = 16 bit
_LFCA7:
	LDA	#$FFFF
	STA	$7E6361.L
_LFCAE:
	LDA	$7E6363.L
	CMP	#$FFFF
	BEQ	_LFCD4

	SEP	#$30		; A/Mem = 8 bit, X/Y = 8 bit
	TAY
	LDA	#$07
	JSL	$848000
	REP	#$30		; A/Mem = 16 bit, X/Y = 16 bit
_LFCC2:
	WAI;JSL	$809464
	JSL	$848004
	LDA	$001FD0.L
	CMP	$001FD2.L
	BNE	_LFCC2
_LFCD4:
	LDA	#$FFFF
	STA	$7E6363.L
	JSL	$848004.L
	JMP	_LFC57


SetupVideo:
	SEP	#$30		; A/Mem = 8 bit, X/Y = 8 bit

	LDA	#$00
	STA	$002105		; Set Video mode 1, 8x8 tiles, 16 color BG1/BG2, 4 color BG3

	LDA	#$04		; Set BG1's Tile Map offset to $0400 (Word address)
	STA	$002107		; And the Tile Map size to 32x32

	STZ	$00210B		; Set BG1's Character VRAM offset to $0000 (word address)

	LDA	#$01		; Enable BG1
	STA	$00212C

	LDA	#$0F
	STA	$002100		; Turn on screen, full Brightness

	RTS

VBlank2:
	REP	#$30		; A/Mem = 16 bit, X/Y = 16 bit
	PHA
	LDA	$004210.L	; Clear NMI flag
	PLA
	RTI

.ENDS
