.LOROM

.SNESHEADER
 ID    "ASSN"
 NAME  "AFTER SCHOOLSNSF"
 LOROM
 SLOWROM
 CARTRIDGETYPE $00
 ROMSIZE $0B
 SRAMSIZE $00
 COUNTRY $00
 LICENSEECODE $33
 VERSION $00
.ENDSNES

.MEMORYMAP
 SLOTSIZE $8000
 DEFAULTSLOT 0
 SLOT 0 $8000
.ENDME

.ROMBANKSIZE $8000
.ROMBANKS 1

.SNESNATIVEVECTOR               ; Define Native Mode interrupt vector table
  COP EmptyHandler
  BRK EmptyHandler
  ABORT EmptyHandler
  NMI VBlank
  IRQ EmptyHandler
.ENDNATIVEVECTOR

.SNESEMUVECTOR                  ; Define Emulation Mode interrupt vector table
  COP EmptyHandler
  ABORT EmptyHandler
  NMI EmptyHandler
  RESET Start
  IRQBRK EmptyHandler
.ENDEMUVECTOR


.BANK 0 SLOT 0

.ORG $7F00
.SECTION "SETUP" SEMIFREE

.DEFINE REQUESTCODE1 = $FF00
	.db	$01
.DEFINE REQUESTCODE2 = $FF01
	.db	$00

Start:

	SEI

	CLC
	XCE

	REP	#$38		; A/Mem = 16 bit, X/Y = 16 bit, decimal = off

	LDX	#$1FFF		;Setup the stack
	TXS			;Transfer Index X to Stack Pointer Register

	SEP	#$30		; A/Mem = 8 bit, X/Y = 8 bit

	STZ	$1000
	STZ	$1001
	STZ	$1002

	JSL	$2C8000

	LDA	#$06
	STA	$1000
	LDA	#$3C
	STA	$1001
	LDA	#$00
	STA	$1002

	JSL	$2C8000

	LDA	REQUESTCODE2
	BEQ	_BGMPLAY

	LDA	#$02
	STA	$1000
	LDA	#$06
	STA	$1001
	LDA	#$00
	STA	$1002

	JSL	$2C8000

	JSL	$2C8003

	LDA	#$03
	STA	$1000
	LDA	#$00
	STA	$1002

	JSL	$2C8000

	JSL	$2C8003


_BGMPLAY:
	LDA	#$02
	STA	$1000
	LDA	REQUESTCODE1
	STA	$1001
	LDA	REQUESTCODE2
	STA	$1002

	JSL	$2C8000

	JSR	SetupVideo

	LDA	#$80
	STA	$4200		; Enable NMI
	
	CLI

_VLP:	WAI

	BRA	_VLP


SetupVideo:

	LDA	#$00
	STA	$2105		; Set Video mode 1, 8x8 tiles, 16 color BG1/BG2, 4 color BG3

	LDA	#$04		; Set BG1's Tile Map offset to $0400 (Word address)
	STA	$2107		; And the Tile Map size to 32x32

	STZ	$210B		; Set BG1's Character VRAM offset to $0000 (word address)

	LDA	#$01		; Enable BG1
	STA	$212C

	LDA	#$0F
	STA	$2100		; Turn on screen, full Brightness

	RTS

VBlank:
	JSL	$2C8003

	PHA
	LDA	$4210.w		; Clear NMI flag
	PLA

EmptyHandler:
	RTI

.ENDS


