#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "zlib/zlib.h"

#ifdef WINGUI

#define _WIN32_WINNT 0x400

#include <windows.h>
#include <commdlg.h>
#include <shlwapi.h>
#include <shlobj.h>
#include <tchar.h>
#pragma comment(linker,"/SUBSYSTEM:WINDOWS")
#pragma comment(lib,"user32.lib")
#pragma comment(lib,"shell32.lib")
#pragma comment(lib,"shlwapi.lib")
#pragma comment(lib,"comdlg32.lib")
#pragma comment(lib,"ole32.lib")

#ifndef BIF_NEWDIALOGSTYLE
#define BIF_NEWDIALOGSTYLE 0x0040
#endif

#ifndef BIF_USENEWUI
#define BIF_USENEWUI           (BIF_NEWDIALOGSTYLE | BIF_EDITBOX)
#endif

#endif

static unsigned char as2drv[] = {
#include "as2drv.h"
};

static unsigned char ab2drv[] = {
#include "ab2drv.h"
};

static unsigned char ct2drv[] = {
#include "ct2drv.h"
};

static unsigned char fe2drv[] = {
#include "fe2drv.h"
};

static unsigned char fs2drv[] = {
#include "fs2drv.h"
};

static unsigned char ow2drv[] = {
#include "ow2drv.h"
};

static unsigned char mm2drv[] = {
#include "mm2drv.h"
};

static unsigned char g32drv[] = {
#include "g32drv.h"
};


static unsigned char dw2drv[] = {
#include "dw2drv.h"
};


class conv
{
	int errmsg(int n, char *sarg = 0, int larg = 0)
	{
#ifdef WINGUI
		char buf[MAX_PATH + 32];
#else
		char buf[256 + 32];
#endif
		switch (n)
		{
		case 1:
			sprintf(buf, "%s\n", "Short of memory");
			break;
		case 2:
			sprintf(buf, "%s:%s\n", "File read error", sarg);
			break;
		case -3:
			sprintf(buf, "%s:%d\n", "Broken file", larg);
			break;
		case 3:
			sprintf(buf, "%s\n", "Unknown rom", larg);
			break;
		case 4:
			sprintf(buf, "%s:%s\n", "File write error", sarg);
			break;
		case 5:
			sprintf(buf, "%s\n", "zlib error", larg);
			break;
		}
#ifdef WINGUI
		MessageBox(NULL, buf, "Error", MB_OK);
#else
		fputs(buf, stderr);
#endif
		return n;
	}

	enum { BUF_SIZE = 0x400000 };
	unsigned char *smc;
	unsigned char *bin;
	unsigned char *snsf;
	void term()
	{
		freesmc();
		freebin();
		freesnsf();
	}
	void freesmc()
	{
		if (smc)
		{
			free(smc);
			smc = 0;
		}
	}
	void freebin()
	{
		if (bin)
		{
			free(bin);
			bin = 0;
		}
	}
	void freesnsf()
	{
		if (snsf)
		{
			free(snsf);
			snsf = 0;
		}
	}
	static void setword(unsigned char *p, long dw)
	{
		p[0] = (unsigned char)((dw >> (8 * 0)) & 0xff);
		p[1] = (unsigned char)((dw >> (8 * 1)) & 0xff);
	}
	static void setdword(unsigned char *p, long dw)
	{
		p[0] = (unsigned char)((dw >> (8 * 0)) & 0xff);
		p[1] = (unsigned char)((dw >> (8 * 1)) & 0xff);
		p[2] = (unsigned char)((dw >> (8 * 2)) & 0xff);
		p[3] = (unsigned char)((dw >> (8 * 3)) & 0xff);
	}
public:
	conv()
	{
		smc = 0;
		bin = 0;
		snsf = 0;
	}
	~conv()
	{
		term();
	}
	int run(char *path)
	{
		term();

		smc = (unsigned char *)malloc(BUF_SIZE);
		bin = (unsigned char *)malloc(BUF_SIZE);
		snsf = (unsigned char *)malloc(BUF_SIZE);
		if (!smc || !bin || !snsf) return errmsg(1);

		FILE *fp = fopen(path, "rb");
		if (!fp) return errmsg(2, path);
		fread(smc, 1, BUF_SIZE, fp);
		fclose(fp);
		enum {
			rt_un,
			rt_ct,
			rt_fe,
			rt_fs,
			rt_as,
			rt_mm,
			rt_g3,
			rt_dw,
			rt_ow,
			rt_ab
		} r_type = rt_un;
		char *r_lib;
		char *r_fmt;
		char *r_tag;
		const unsigned char *r_drv = 0;
		unsigned r_base, r_top, r_size, r_len, r_ofs, r_dtop;
		int r_scd, r_ecd;
		unsigned r_dlen = 0x100;
		if (memcmp(smc + 0xffc0, "CHRONO TRIGGER", 14) == 0)
		{
			r_ofs = 0;
			r_type = rt_ct;
		}
		else if (memcmp(smc + 0xffc0 + 0x200, "CHRONO TRIGGER", 14) == 0)
		{
			r_ofs= 0x200;
			r_type = rt_ct;
		}
		else if (memcmp(smc + 0x7fc0, "\xB1\xC6\xB7\xA5\xCA\xDE\xB8\xDA\xC2", 9) ==0)
		{
			r_ofs= 0x0;
			r_type = rt_ab;
		}
		else if (memcmp(smc + 0x7fc0 + 0x200, "\xB1\xC6\xB7\xA5\xCA\xDE\xB8\xDA\xC2", 9) ==0)
		{
			r_ofs= 0x200;
			r_type = rt_ab;
		}
		else if (memcmp(smc + 0x7fc0, "AFTER SCHOOL", 12) == 0)
		{
			r_ofs= 0x0;
			r_type = rt_as;
		}
		else if (memcmp(smc + 0x7fc0 + 0x200, "AFTER SCHOOL", 12) == 0)
		{
			r_ofs= 0x200;
			r_type = rt_as;
		}
		else if (memcmp(smc + 0xffc0, "Feda", 4) == 0)
		{
			r_ofs = 0;
			r_type = rt_fe;
		}
		else if (memcmp(smc + 0xffc0 + 0x200, "Feda", 4) == 0)
		{
			r_ofs= 0x200;
			r_type = rt_fe;
		}
		else if (memcmp(smc + 0xffc0, "FURAI NO SIREN", 14) == 0)
		{
			r_ofs = 0;
			r_type = rt_fs;
		}
		else if (memcmp(smc + 0xffc0 + 0x200, "FURAI NO SIREN", 14) == 0)
		{
			r_ofs= 0x200;
			r_type = rt_fs;
		}
		else if (memcmp(smc + 0x7fc0, "OUTER WORLD", 11) == 0)
		{
			r_ofs = 0;
			r_type = rt_ow;
		}
		else if (memcmp(smc + 0x7fc0 + 0x200, "OUTER WORLD", 11) == 0)
		{
			r_ofs= 0x200;
			r_type = rt_ow;
		}
		else if (memcmp(smc + 0x7fc0, "\xD3\xDD\xBD\xC0\x2D\xD2\x2D\xB6\x2D\x20\xB7\xAF\xBD\xDE", 14) == 0)
		{
			r_ofs = 0;
			r_type = rt_mm;
		}
		else if (memcmp(smc + 0x7fc0 + 0x200, "\xD3\xDD\xBD\xC0\x2D\xD2\x2D\xB6\x2D\x20\xB7\xAF\xBD\xDE", 14) == 0)
		{
			r_ofs= 0x200;
			r_type = rt_mm;
		}
		else if (memcmp(smc + 0x7fc0, "GRADIUS 3", 9) == 0)
		{
			r_ofs = 0;
			r_type = rt_g3;
		}
		else if (memcmp(smc + 0x7fc0 + 0x200, "GRADIUS 3", 9) == 0)
		{
			r_ofs= 0x200;
			r_type = rt_g3;
		}
		else if (memcmp(smc + 0xffc0, "DOWN THE WORLD", 14) == 0)
		{
			r_ofs = 0;
			r_type = rt_dw;
		}
		else if (memcmp(smc + 0xffc0 + 0x200, "DOWN THE WORLD", 14) == 0)
		{
			r_ofs= 0x200;
			r_type = rt_dw;
		}
		else
		{
			return errmsg(3);
		}
		switch (r_type)
		{
		case rt_ct:
			r_drv = ct2drv;
			r_base = 0x00ff00;
			r_dtop = r_base;
			r_top =  0x070000;
			r_size = 0x0c0000 - r_top;
			r_len =  0x100000;
			r_lib = "ct.snsflib";
			r_tag = "[TAG]_lib=ct.snsflib\x0a";
			r_fmt = "ct%03d.minisnsf";
			r_scd = 1;
			r_ecd = 0x52 + 0x6a;//82 + se;
			//smc[r_ofs + 0x70ae9] = r_ecd + 1;
			break;
		case rt_as:
			r_drv = as2drv;
			r_base = 0x007f00;
			r_dtop = r_base;
			r_top =  0x160000;
			r_size = 0x180000 - r_top;
			r_len =  0x180000;
			r_lib = "as.snsflib";
			r_tag = "[TAG]_lib=as.snsflib\x0a";
			r_fmt = "as%03d.minisnsf";
			r_scd = 1;
			r_ecd = 39;
			break;
		case rt_ab:
			r_drv = ab2drv;
			r_base = 0x000000;
			r_dtop = 0x007e00;
			r_dlen = 0x000200;
			r_top =  0x000000;
			r_size = 0x100000 - r_top;
			r_len =  0x200000;
			r_lib = "ab.snsflib";
			r_tag = "[TAG]_lib=ab.snsflib\x0a";
			r_fmt = "ab%03d.minisnsf";
			r_scd = 0;
			r_ecd = 11;
			smc[r_ofs + 0x80a3 - 0x8000] = 0x4C;
			smc[r_ofs + 0x80a4 - 0x8000] = 0x70;
			smc[r_ofs + 0x80a5 - 0x8000] = 0xFE;
//			smc[r_ofs + 0x80a4 - 0x8000] = 0x03;
/*
			smc[r_ofs + 0x9464 - 0x8000] = 0x6B;
			smc[r_ofs + 0xD9CD - 0x8000] = 0x6B;
			smc[r_ofs + 0x9501 - 0x8000] = 0x6B;
			smc[r_ofs + 0xE605 - 0x8000] = 0x6B;
*/
			//smc[r_ofs + 0x9464 - 0x8000] = 0xCB;
			//smc[r_ofs + 0x9465 - 0x8000] = 0x6B;
			//smc[r_ofs + 0x0] = 0;
			//smc[r_ofs + 0x1] = 0;
			break;
		case rt_fe:
			r_drv = fe2drv;
			r_base = 0x0ff00;
			r_dtop = r_base;
			r_top =  0x50000;
			r_size = 0x90000 - r_top;
			r_len =  0x90000;
			r_lib = "fe.snsflib";
			r_tag = "[TAG]_lib=fe.snsflib\x0a";
			r_fmt = "fe%03d.minisnsf";
			r_scd = 1;
			r_ecd = 97;
			break;
		case rt_fs:
			r_drv = fs2drv;
			r_base = 0x000000;
			r_dtop = 0x00ff00;
//			r_top =  0x000000;
			r_top =  0x008000;
			r_size = 0x200000 - r_top;
			r_len =  0x200000;
			r_lib = "fs.snsflib";
			r_tag = "[TAG]_lib=fs.snsflib\x0a";
			r_fmt = "fs%03d.minisnsf";
			r_scd = 0;
			r_ecd = 0x123;
			break;
		case rt_ow:
			r_drv = ow2drv;
			r_base = 0x000000;
			r_dtop = 0x007e00;
			r_dlen = 0x000200;
			r_top =  0x000000;
			r_size = 0x100000 - r_top;
			r_len =  0x100000;
			r_lib = "ow.snsflib";
			r_tag = "[TAG]_lib=ow.snsflib\x0a";
			r_fmt = "ow%03d.minisnsf";
			r_scd = 9;
			r_ecd = 11;
			break;
		case rt_mm:
			r_drv = mm2drv;
			r_base = 0x000000;
			r_dtop = 0x007f00;
			r_dlen = 0x000100;
			r_top =  0x0D0000;
			r_size = 0x100000 - r_top;
			r_len =  0x100000;
			r_lib = "mm.snsflib";
			r_tag = "[TAG]_lib=mm.snsflib\x0a";
			r_fmt = "mm%03d.minisnsf";
			r_scd = 0;
			r_ecd = 26 + 60;
			break;
		case rt_g3:
			r_drv = g32drv;
			r_base = 0x000000;
			r_dtop = 0x007c00;
			r_dlen = 0x000400;
			r_top =  0x000000;
			r_size = 0x080000 - r_top;
			r_len =  0x080000;
			r_lib = "g3.snsflib";
			r_tag = "[TAG]_lib=g3.snsflib\x0a";
			r_fmt = "g3_se%02x.minisnsf";
			r_scd = 0;
			r_ecd = 256 + 28;
			break;
		case rt_dw:
			r_drv = dw2drv;
			r_base = 0x000000;
			r_dtop = 0x00fc00;
			r_dlen = 0x000400;
			r_top =  0x000000;
			r_size = 0x200000 - r_top;
			r_len =  0x200000;
			r_lib = "dw.snsflib";
			r_tag = "[TAG]_lib=dw.snsflib\x0a";
			r_fmt = "dw%03d.minisnsf";
			r_scd = 1;
			r_ecd = 59 + 59;
			break;
		}
		memset(bin, 0x00, BUF_SIZE);

		setdword(bin + 0, r_base);
		setdword(bin + 4, r_len - r_base);

		memcpy(bin + 8 + r_top - r_base, smc + r_ofs + r_top, r_size);

		if (r_type == rt_ab)
		{
			/* svJbg */
			memset(bin + 8 + 0x08000 - r_base, 0x00, 0x0dd20 - 0x08000);
			memset(bin + 8 + 0x0dddb - r_base, 0x00, 0x20000 - 0x0dddb);
			memset(bin + 8 + 0x88000 - r_base, 0x00, 0xfa000 - 0x88000);
		}
		else if (r_type == rt_fs)
		{
			/* svJbg */
			memset(bin + 8 + 0x20000 - r_base, 0x00, 0x1d4000 - 0x20000);
		}
		else if (r_type == rt_g3)
		{
			/* svJbg */
			memset(bin + 8 + 0x10000 - r_base, 0x00, 0x60000 - 0x10000);
		}
		else if (r_type == rt_dw)
		{
			/* svJbg */
			memset(bin + 8 + 0x010000 - r_base, 0x6b, 0x020000 - 0x010000);
			memset(bin + 8 + 0x030000 - r_base, 0x6b, 0x080000 - 0x030000);
			memset(bin + 8 + 0x100000 - r_base, 0x6b, 0x190000 - 0x100000);
		}

		memcpy(bin + 8 + r_dtop - r_base, r_drv, r_dlen);

		setdword(snsf + 0, 0x23465350);
		setdword(snsf + 4, 0);

		uLongf destLen = BUF_SIZE - 0x10;
		if (Z_OK != compress(snsf + 0x10, &destLen, bin, 8 + r_len - r_base))
		{
			return errmsg(5);
		}
		setdword(snsf + 8, destLen);
		setdword(snsf + 0xc, crc32(crc32(0L, Z_NULL, 0), snsf + 0x10, destLen));

#ifdef WINGUI
		class CWDSAVE
		{
			TCHAR savecwd[MAX_PATH];
			bool result;
		public:
			void Save()
			{
				result = GetCurrentDirectory(sizeof(savecwd) / sizeof (savecwd[0]), savecwd) != 0;
			}
			void Restore()
			{
				if (result)
				{
					SetCurrentDirectory(savecwd);
					result = false;
				}
			}
			CWDSAVE()
			{
				result = false;
			}
			~CWDSAVE()
			{
				Restore();
			}
		};
		CWDSAVE cwdsave;
		cwdsave.Save();
		class BFF
		{
		public:
			bool Invoke()
			{
				BROWSEINFO bi;
				TCHAR buf[MAX_PATH];
				buf[0] = 0;
				ZeroMemory(&bi, sizeof(BROWSEINFO));
				bi.pszDisplayName = buf;
				bi.lpszTitle = "Output Location";
				bi.ulFlags = BIF_RETURNONLYFSDIRS | BIF_USENEWUI;
				LPITEMIDLIST  pidl = SHBrowseForFolder(&bi);
				if (!pidl) return false;
				if (SHGetPathFromIDList(pidl, buf))
				{
					SetCurrentDirectory(buf);				
				}
				CoTaskMemFree(pidl);
				return true;
			}
		};
		BFF bff;
		if (!bff.Invoke()) return -1;
#endif

		FILE *wfp;
		wfp = fopen(r_lib, "wb");
		if (!wfp)
		{
			return errmsg(4, r_lib);
		}
		fwrite(snsf, 1, 0x10 + destLen, wfp);
		fclose(wfp);

		for (int s = r_scd; s <= r_ecd; s++)
		{
			int c = s;
			int slen = 1;
			bin[8] = s & 0xff;
			if (r_type == rt_g3)
			{
				if (s < 0x100)
				{
					bin[9] = 0;
					bin[10] = 1;
					slen = 3;
					r_fmt = "g3_se%02x.minisnsf";
				}
				else
				{
					c = ((s << 2) & 0xff);
					bin[8] = c;
					r_fmt = "g3_bgm%02x.minisnsf";
				}
			}
			else if (r_type == rt_as) 
			{
				if (s > 10)
				{
					c = ((s - 10) | 0x80) & 0xff;
					bin[8] = c;
					bin[9] = 1;
					slen = 2;
					r_fmt = "as_se%03d.minisnsf";
				}

			}
			else if (r_type == rt_mm) 
			{
				if (s > 26)
				{
					c = (s - 26) | 0x80;
					bin[8] = c & 0xff;
					bin[9] = 1;
					slen = 2;
					r_fmt = "mm_se%03d.minisnsf";
				}
				else
				{
					r_fmt = "mm%03d.minisnsf";
				}

			}
			else if (r_type == rt_fe) 
			{
				if (s >= 40)
				{
					bin[8] = (s - 39) | 0x80;
					bin[9] = 1;
					slen = 2;
				}
			}
			else if (r_type == rt_ct) 
			{
				r_fmt = "ct%03d.minisnsf";
				if (s > 0x52)
				{
					c = (s - 0x53) | 0x80;
					bin[8] = c;
					slen = 1;
					r_fmt = "ct_se%03d.minisnsf";
				}
				else if (s == 0x18)
				{
					memcpy(bin + 8, ct2drv, 0x100);
					bin[8] = s;
					bin[9] = 0x02;
					slen = 256;
				}
				else if (s == 0x0d)
				{
					memcpy(bin + 8, ct2drv, 0x100);
					bin[8] = s;
					bin[9] = 0x01;
					setword(bin + 10, 15L);
					setword(bin + 12, 15L);
					slen = 256;
				}
				else if (s == 0x23)
				{
					bin[8] = s;
					bin[9] = 0x01;
					setword(bin + 10, 960L);
					setword(bin + 12, 1260L);
					slen = 256;
				}
			}
			else if (r_type == rt_dw) 
			{
				if (s > 59)
				{
					c = s - 60;
					bin[8] = (s - 60) & 0xff;
					bin[9] = 0;
					bin[10] = 1;
					r_fmt = "dw_se%03d.minisnsf";
					slen = 3;
				}
			}
			else if (r_type == rt_fs) 
			{
				if (s >= 0xff)
				{
					bin[8] = s & 0xff;
					bin[9] = (s >> 8) & 0xff;
					slen = 2;
				}
			}
			setdword(bin + 0, r_dtop - r_base);
			setdword(bin + 4, slen);
			destLen = BUF_SIZE - 0x10;
			if (Z_OK != compress(snsf + 0x10, &destLen, bin, 8 + slen)) return errmsg(5);
			setdword(snsf + 8, destLen);
			setdword(snsf + 0xc, crc32(crc32(0L, Z_NULL, 0), snsf + 0x10, destLen));
			memcpy(snsf + 0x10 + destLen, r_tag, strlen(r_tag));

			char pbuf[64];
			sprintf(pbuf, r_fmt, c);
			wfp = fopen(pbuf, "wb");
			if (!wfp) return errmsg(4, pbuf);
			fwrite(snsf, 1, 0x10 + destLen + strlen(r_tag), wfp);
			fclose(wfp);

		}
#ifdef WINGUI
		cwdsave.Restore();
#endif
		return 0;
	}
};

#ifdef WINGUI
int WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	TCHAR arg[MAX_PATH];
	int i;
	class COM {
	private:
		HRESULT herr;
	public:
		COM()
		{
			Init();
		}
		void Init()
		{
			herr = CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
		}
		void Term()
		{
			if (SUCCEEDED(herr))
			{
				CoUninitialize();
				herr = E_UNEXPECTED;
			}
		}
		~COM()
		{
			Term();
		}
	};
	COM x;
	for (i = 0; *lpCmdLine; i++)
	{
		lstrcpy(arg, lpCmdLine);
		PathRemoveArgs(arg);
		lpCmdLine += lstrlen(arg);
		while (*lpCmdLine == _T(' ')) lpCmdLine++;
		if (*arg)
		{
			conv c;
			int ret = c.run(arg);
			if (ret) return ret;
		}
	}
	if (i == 0)
	{
		OPENFILENAME ofn;
		ZeroMemory(&ofn, sizeof(OPENFILENAME));
		ofn.lStructSize = sizeof(OPENFILENAME);
		ofn.lpstrFilter = _T("SFC Cartidge image file(*.SMC)\0*.smc\0All files(*.*)\0*.*\0\0");
		ofn.nFilterIndex = 1;
		ofn.lpstrFile = arg;
		ofn.nMaxFile = sizeof(arg) / sizeof(arg[0]);
		ofn.Flags = OFN_ENABLESIZING | OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_PATHMUSTEXIST | OFN_READONLY | OFN_SHAREAWARE;
		arg[0] = 0;
		if (GetOpenFileName(&ofn) && arg[0])
		{
			conv c;
			int ret = c.run(arg);
			if (ret) return ret;
		}
	}
	x.Term();
	return 0;
}

#else
int main(int argc, char **argv)
{
	int i;	
	for (i = 1; i < argc; i++)
	{
		conv c;
		int ret = c.run(argv[i]);
		if (ret) return ret;
	}
	return 0;
}
#endif
