.HIROM

.SNESHEADER
 ID    "DWSN"
 NAME  "DOWN THE WORLD SNSF"
 HIROM
 FASTROM
 CARTRIDGETYPE $00
 ROMSIZE $0B
 SRAMSIZE $00
 COUNTRY $00
 LICENSEECODE $33
 VERSION $00
.ENDSNES

.MEMORYMAP
 SLOTSIZE $8000
 DEFAULTSLOT 0
 SLOT 0 $8000
.ENDME

.ROMBANKSIZE $8000
.ROMBANKS 2

.SNESNATIVEVECTOR               ; Define Native Mode interrupt vector table
  COP EmptyHandler
  BRK EmptyHandler
  ABORT EmptyHandler
  NMI VSYNCENTRY
  IRQ IRQENTRY
.ENDNATIVEVECTOR

.SNESEMUVECTOR                  ; Define Emulation Mode interrupt vector table
  COP EmptyHandler
  ABORT EmptyHandler
  NMI EmptyHandler
  RESET RESETENTRY
  IRQBRK EmptyHandler
.ENDEMUVECTOR


.BANK 1 SLOT 0

.ORG $7C00
.SECTION "SETUP" SEMIFREE

.DEFINE REQUESTCODE1 = $FC00
	.dw	$0008
.DEFINE REQUESTCODE2 = $FC02
	.dw	$0000
RESETGATE:
	BRA	Start
	NOP
	NOP
VSYNCGATE:
	JMP	VBlank
RESETENTRY:
	JMP	$C0FC04.L
VSYNCENTRY:
	JMP	$C29C23.L
IRQENTRY:
	JMP	$C29D3D.L

Start:

	SEI

	CLC
	XCE

	SEP #$20

	LDA #$01
	STA $00420D.L

	REP #$30
	SEP #$20

	LDA #$00
	STA $004200.L
	STA $00420B.L
	STA $00420C.L
	LDA #$80
	STA $002100.L
	REP #$30

	LDX #$1FFF
	TXS

	CLI

	;SAVE HOT-BOOT FLAG
	LDA $000BC6.L
	PHA

	LDA #$0000
	STA $002181.L
	SEP #$20
	LDA #$00
	STA $002183.L
	LDA #$08
	STA $004370.L
	LDA #$80
	STA $004371.L
	REP #$30
	LDA #$0002
	STA $004372.L
	SEP #$20
	LDA #$C2
	STA $004374.L
	REP #$30
	LDA #$1800
	STA $004375.L
	SEP #$20
	LDA #$80
	STA $00420B.L
	REP #$30

	LDA #$2000
	STA $002181.L
	SEP #$20
	LDA #$7E
	STA $002183.L
	LDA #$08
	STA $004370.L
	LDA #$80
	STA $004371.L
	REP #$30
	LDA #$0002
	STA $004372.L
	SEP #$20
	LDA #$C2
	STA $004374.L
	REP #$30
	LDA #$E000
	STA $004375.L
	SEP #$20
	LDA #$80
	STA $00420B.L
	REP #$30

	LDA #$0000
	STA $002181.L
	SEP #$20
	LDA #$7F
	STA $002183.L
	LDA #$08
	STA $004370.L
	LDA #$80
	STA $004371.L
	REP #$30
	LDA #$0002
	STA $004372.L
	SEP #$20
	LDA #$C2
	STA $004374.L
	REP #$30
	LDA #$0000
	STA $004375.L
	SEP #$20
	LDA #$80
	STA $00420B.L
	REP #$30

	;RESTORE HOT-BOOT FLAG
	PLA
	STA $000BC6.L

	;SOUND DRIVER INIT
	JSL $DC0000

	LDA REQUESTCODE2.L
	BNE _SEPLAY
	LDA REQUESTCODE1.L
	CMP #$0001
	BEQ _OPENING

	;BGM

	STA $7E2100.L

	SEP #$20
	LDA #$00
	STA $002100.L
	LDA #$81
	STA $004200.L
	REP #$30

	JSL $DC000F
	JSL $DC0003

_VLP:	WAI

	BRA	_VLP

	;OPENING

_OPENING:

	JSR OPSETUP

	SEP #$20
	LDA #$00
	STA $002100.L
	LDA #$81
	STA $004200.L
	REP #$30

	;OPENING
	JSL $DA0020
	BRA	_VLP

_SEPLAY:

	SEP #$20
	LDA #$00
	STA $002100.L
	LDA #$81
	STA $004200.L
	REP #$30

	LDA #$0000
	STA $7E2100.L

	JSL $DC000F
	JSL $DC0003

	LDA REQUESTCODE1.L
	JSL $DC0012

	JSL $DC0009
	JSL $DC0009
	JSL $DC0009
	JSL $DC0009

_SELP:
	WAI
	BRA	_SELP

VBlank:
	REP	#$30
	PHB
	PHA
	PHD
	PHX
	PHY

	LDA	#$0000
	TCD
	PHA
	PLB

	LDA	$4210		; Clear NMI flag

	JSL	$DC0009

	REP	#$30
	PLY
	PLX
	PLD
	PLA
	PLB

EmptyHandler:
	RTI

OPSETUP:
	SEP #$20
	LDA #$00
	PHA
	PLB

	REP #$30
	LDA #$0006
	STA $000F3C.L
	LDA $7E7F15.L
	STA $000F3E.L

	;JSL $C2086A
	LDA #$0000

	TAX
	LDA $C05942,x
	AND #$00FF
	STA $000288.L
	INX
	LDY #$0000
_OS1:
	LDA $000288.L
	BEQ _OS2
	DEC A
	STA $000288.L
	LDA $C05942,x
	AND #$00FF
	STA $029E,y
	INX
	TYA
	CLC
	ADC #$0016
	TAY
	BRA _OS1
 _OS2:
 	LDA #$0000
 	STA $029E,y

 	RTS

.ENDS


