.HIROM

.SNESHEADER
 ID    "FESN"
 NAME  "Feda        SNSF"
 HIROM
 FASTROM
 CARTRIDGETYPE $00
 ROMSIZE $0B
 SRAMSIZE $00
 COUNTRY $00
 LICENSEECODE $33
 VERSION $00
.ENDSNES

.MEMORYMAP
 SLOTSIZE $8000
 DEFAULTSLOT 0
 SLOT 0 $8000
.ENDME

.ROMBANKSIZE $8000
.ROMBANKS 2

.SNESNATIVEVECTOR               ; Define Native Mode interrupt vector table
  COP EmptyHandler
  BRK EmptyHandler
  ABORT EmptyHandler
  NMI VBlank
  IRQ EmptyHandler
.ENDNATIVEVECTOR

.SNESEMUVECTOR                  ; Define Emulation Mode interrupt vector table
  COP EmptyHandler
  ABORT EmptyHandler
  NMI EmptyHandler
  RESET Start
  IRQBRK EmptyHandler
.ENDEMUVECTOR


.BANK 1 SLOT 0

.ORG $7F00
.SECTION "SETUP" SEMIFREE

.DEFINE REQUESTCODE1 = $FF00
	.db	$0A
.DEFINE REQUESTCODE2 = $FF01
	.db	$00

Start:

	SEI

	CLC
	XCE

	REP	#$38		; A/Mem = 16 bit, X/Y = 16 bit, decimal = off
	
;	LDX	#$1FFF		;Setup the stack
;	TXS			;Transfer Index X to Stack Pointer Register

	SEP	#$30		; A/Mem = 8 bit, X/Y = 8 bit

	LDA	#$00
	TAX

_JLP:	STZ	$1F00,X
	INX
	BNE	_JLP


	STZ	$1F00
	STZ	$1F01
	STZ	$1F02

	JSL	$C50000

	LDA	#$01
	STA	$1F00
	STZ	$1F01
	STZ	$1F02

	JSL	$C50000

	LDA	#$02
	STA	$1F00
	LDA	#$80
	STA	$1F01
	STZ	$1F02

	JSL	$C50000

	LDA	#$09
	STA	$1F01
	LDA	#$02
	STA	$1F00
	STZ	$1F02

	JSL	$C50000

	JSL	$C50003
;	JSL	$C50003


	LDA	REQUESTCODE2
	STA	$1F02
	LDA	REQUESTCODE1
	STA	$1F01
	LDA	#$02
	STA	$1F00

	JSL	$C50000

	STZ	$0479
	STZ	$047A
	STZ	$047B
	STZ	$047C

	LDA	#$01
	STA	$2D

	JSR	SetupVideo

	LDA	#$80
	STA	$4200		; Enable NMI
	
	CLI

_VLP:	WAI

	BRA	_VLP


SetupVideo:

	LDA	#$00
	STA	$2105		; Set Video mode 1, 8x8 tiles, 16 color BG1/BG2, 4 color BG3

	LDA	#$04		; Set BG1's Tile Map offset to $0400 (Word address)
	STA	$2107		; And the Tile Map size to 32x32

	STZ	$210B		; Set BG1's Character VRAM offset to $0000 (word address)

	LDA	#$01		; Enable BG1
	STA	$212C

	LDA	#$0F
	STA	$2100		; Turn on screen, full Brightness

	RTS

VBlank:
	REP	#$30
	PHA

;	INC	$2F

;	SEP	#$20
;	LDA	$2D
;	LSR
;	BCC	_VBSKIP

;	LDA	#$01
;	TRB	$2D

	JSL	$C50003

;	LDA	#$01
;	TSB	$2D

_VBSKIP:
	SEP	#$30
	LDA	$4210.w		; Clear NMI flag

	REP	#$30
	PLA

EmptyHandler:
	RTI

.ENDS


