.LOROM

.SNESHEADER
 ID    "MMSN"
 NAME  "MM KIDS SNSF"
 LOROM
 SLOWROM
 CARTRIDGETYPE $00
 ROMSIZE $0A
 SRAMSIZE $00
 COUNTRY $00
 LICENSEECODE $33
 VERSION $00
.ENDSNES

.MEMORYMAP
 SLOTSIZE $8000
 DEFAULTSLOT 0
 SLOT 0 $8000
.ENDME

.ROMBANKSIZE $8000
.ROMBANKS 1

.SNESNATIVEVECTOR               ; Define Native Mode interrupt vector table
  COP EmptyHandler
  BRK EmptyHandler
  ABORT EmptyHandler
  NMI VBlank
  IRQ EmptyHandler
.ENDNATIVEVECTOR

.SNESEMUVECTOR                  ; Define Emulation Mode interrupt vector table
  COP EmptyHandler
  ABORT EmptyHandler
  NMI EmptyHandler
  RESET Start
  IRQBRK EmptyHandler
.ENDEMUVECTOR


.BANK 0 SLOT 0

.ORG $7F00
.SECTION "SETUP" SEMIFREE

.DEFINE REQUESTCODE1 = $80FF00
	.db	$02
.DEFINE REQUESTCODE2 = $80FF01
	.db	$00

Start:

	SEI

	CLC
	XCE

	SEP	#$20
	REP	#$10
	LDX	#$1FFF		;Setup the stack
	TXS			;Transfer Index X to Stack Pointer Register

	LDA	#$FF
	STA	$05
	LDA	#$81
	STA	$7E0041

	STZ	$0300
	JSL	$1A8000

	LDX	#$0032
_WLP:	DEX
	BNE	_WLP

	LDA	#$01
	STA	$0300
	STZ	$0301
	JSL	$1A8000

	STZ	$05

	LDA	#$03
	STA	$0300
	STZ	$0301
	STZ	$0302
	JSL	$1A8000

	LDA	REQUESTCODE2
	BEQ	_BGM

	LDA	#$02
	STA	$0300
	LDA	#$0B
	STA	$0301
	LDA	#$00
	STA	$0302
	JSL	$1A8000

	LDA	#$03
	STA	$0300
	STZ	$0301
	STZ	$0302
	JSL	$1A8000

_BGM:
	LDA	#$02
	STA	$0300
	LDA	REQUESTCODE1
	STA	$0301
	LDA	REQUESTCODE2
	STA	$0302
	JSL	$1A8000

	JSR	SetupVideo

	LDA	#$80
	STA	$4200		; Enable NMI

	CLI

_VLP:	WAI

	BRA	_VLP


SetupVideo:

	STZ	$2105		; Set Video mode 1, 8x8 tiles, 16 color BG1/BG2, 4 color BG3

	LDA	#$04		; Set BG1's Tile Map offset to $0400 (Word address)
	STA	$2107		; And the Tile Map size to 32x32

	STZ	$210B		; Set BG1's Character VRAM offset to $0000 (word address)

	LDA	#$01		; Enable BG1
	STA	$212C

	LDA	#$0F
	STA	$2100		; Turn on screen, full Brightness

	RTS

VBlank:
	SEP	#$30		; A/Mem = 8 bit, X/Y = 8 bit

	PHA
	LDA	$4210.w		; Clear NMI flag

	JSL	$1A8003

	PLA

EmptyHandler:
	RTI

.ENDS


